


#Load the non-standardised section table of Skomer with mean cliff orientation and slope
SectorsTableRaw<-read.csv(file.choose())



SectorsTableRaw$ApsectClass[SectorsTableRaw$MeanSectorAspectCircular>=135 & SectorsTableRaw$MeanSectorAspectCircular<315]<-"WindWard"
SectorsTableRaw$ApsectClass[SectorsTableRaw$MeanSectorAspectCircular>=315]<-"leeWard"
SectorsTableRaw$ApsectClass[SectorsTableRaw$MeanSectorAspectCircular<135]<-"leeWard"

SectorsTableRaw$ApsectClass<-as.factor(SectorsTableRaw$ApsectClass)

SectorsTableRaw$ApsectClass = relevel(SectorsTableRaw$ApsectClass, ref = "WindWard") # set leeWard as reference


table(SectorsTableRaw$ApsectClass)

#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Any COUNT HYPOTHESIS


SectorsTableRaw$ColPresence[SectorsTableRaw$Count==0]<-0
SectorsTableRaw$ColPresence[SectorsTableRaw$Count>0]<-1

SectorsTableRaw$ColPresence<-as.numeric(SectorsTableRaw$ColPresence)


SectorsTable$ColPresence[SectorsTable$Count==0]<-0
SectorsTable$ColPresence[SectorsTable$Count>0]<-1

SectorsTable$ColPresence<-as.numeric(SectorsTable$ColPresence)


#Global model
modelGML_ASPECT_AnyCOunt<-glm(ColPresence ~
                                
                                ApsectClass+MeanSectorSlope
                              
                              , family = binomial(link = "logit")
                              , maxit = 10000
                              ,data = SectorsTableRaw#SectorsTableRaw
                              ,offset =  log(Area)
                              ,na.action = "na.fail"
                              
)
summary.glm(modelGML_ASPECT_AnyCOunt)



#Use dredge  to get the model set from the standardized global model
options(na.action = "na.fail")
model.set2<-dredge(modelGML_ASPECT_AnyCOunt, rank = "BIC",extra = "R^2")
options(na.action = "na.omit")



modelGML_ASPECT_AnyCOuntSimplest<-get.models(model.set2, subset = 1)[[1]]

summary(modelGML_ASPECT_AnyCOuntSimplest)
PseudoR2(modelGML_ASPECT_AnyCOuntSimplest)




#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>LARGEST COUNT HYPOTHESIS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>




SectorsTableForAlrgestColoniesRAW<-subset(SectorsTableRaw, (SectorsTableRaw$Count==0 | SectorsTableRaw$Count>=592))
SectorsTableForAlrgestColoniesRAW$ColPresence[SectorsTableForAlrgestColoniesRAW$Count<592]<-0
SectorsTableForAlrgestColoniesRAW$ColPresence[SectorsTableForAlrgestColoniesRAW$Count>=592]<-1



table(SectorsTableForAlrgestColoniesRAW$ApsectClass)


SectorsTableForAlrgestColoniesRAW$ColPresence<-as.numeric(SectorsTableForAlrgestColoniesRAW$ColPresence)


SectorsTableForAlrgestColoniesRAW$ApsectClass<-as.factor(SectorsTableForAlrgestColoniesRAW$ApsectClass)

SectorsTableForAlrgestColoniesRAW$ApsectClass = relevel(SectorsTableForAlrgestColoniesRAW$ApsectClass, ref = "WindWard") # set leeWard as reference


#Global model
modelGML_ASPECT_LargestCounts<-glm(ColPresence ~
                                     
                                     ApsectClass+MeanSectorSlope
                                   
                                   
                                   , family = binomial(link = "logit")
                                   , maxit = 10000
                                   ,data = SectorsTableForAlrgestColoniesRAW
                                   ,offset =  log(Area)
                                   ,na.action = "na.fail"
                                   
)
summary.glm(modelGML_ASPECT_LargestCounts)


PseudoR2(modelGML_ASPECT_LargestCounts)


#Use dredge  to get the model set from the standardized global model
options(na.action = "na.fail")
model.set2<-dredge(modelGML_ASPECT_LargestCounts, rank = "BIC",extra = "R^2")
options(na.action = "na.omit")


modelGML_ASPECT_LargestCountsSimplestSkomer<-get.models(model.set2, subset = 1)[[1]]

summary(modelGML_ASPECT_LargestCountsSimplestSkomer)
PseudoR2(modelGML_ASPECT_LargestCountsSimplestSkomer)




#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>11 Densest HYPOTHESIS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>




SectorsTableForDensestColoniesRAW<-subset(SectorsTableRaw, (SectorsTableRaw$Density==0 | SectorsTableRaw$Density>=0.835))
SectorsTableForDensestColoniesRAW$ColPresence[SectorsTableForDensestColoniesRAW$Density<0.835]<-0
SectorsTableForDensestColoniesRAW$ColPresence[SectorsTableForDensestColoniesRAW$Density >=0.835]<-1


SectorsTableForDensestColoniesRAW$ColPresence<-as.numeric(SectorsTableForDensestColoniesRAW$ColPresence)


SectorsTableForDensestColoniesRAW$ApsectClass<-as.factor(SectorsTableForDensestColoniesRAW$ApsectClass)

SectorsTableForDensestColoniesRAW$ApsectClass = relevel(SectorsTableForDensestColoniesRAW$ApsectClass, ref = "WindWard") # set leeWard as reference





#Global model
modelGML_ASPECT_Densest<-glm(ColPresence ~
                               
                               ApsectClass+MeanSectorSlope
                             
                             , family = binomial(link = "logit")
                             , maxit = 10000
                             ,data = SectorsTableForDensestColoniesRAW
                             #,offset =  log(Area)  #Don't use offset for the 11 densest as the are is incorporated in the response classified by density
                             ,na.action = "na.fail"
                             
)
summary.glm(modelGML_ASPECT_Densest)

PseudoR2(modelGML_ASPECT_Densest)


#Use dredge  to get the model set from the standardized global model
options(na.action = "na.fail")
model.set2<-dredge(modelGML_ASPECT_Densest, rank = "BIC",extra = "R^2")
options(na.action = "na.omit")



modelGML_ASPECT_DensestSimplest<-get.models(model.set2, subset = 2)[[1]]

summary(modelGML_ASPECT_DensestSimplest)
PseudoR2(modelGML_ASPECT_DensestSimplest)








