


library(tcltk)

#The following code is adapted for the needs of this study from:

#Brger, L. & Nudds, T. D. Fire, humans, and climate: modeling distribution dynamics 
#of boreal forest waterbirds. Ecological Applications 24, 121-141 (2014).


#The example below works for the model of 10 largest colonies under SW wind conditions.

#Use the airflow model of 10 Largest colonies on Skomer (fround in the script: "BinomialModelsOfEachWindDirectionAndClassificationOnSkomer"),
#to predict the largest colonies on Skokholm.



#Load the standardised section table of SW wind on Skokholm:
SectorsTableSkokholm<-read.csv(file.choose())



SectorsTableForAlrgestColoniesSkoklholm<-subset(SectorsTableSkokholm, (SectorsTableSkokholm$Count==0 | SectorsTableSkokholm$Count>=146))
SectorsTableForAlrgestColoniesSkoklholm$ColPresence[SectorsTableForAlrgestColoniesSkoklholm$Count<146]<-0
SectorsTableForAlrgestColoniesSkoklholm$ColPresence[SectorsTableForAlrgestColoniesSkoklholm$Count>=146]<-1

SectorsTableForAlrgestColoniesSkoklholm$ColPresence<-as.numeric(SectorsTableForAlrgestColoniesSkoklholm$ColPresence)



obsDetectAlfl<- SectorsTableForAlrgestColoniesSkoklholm$ColPresence
mu.NullMod<-predict(topModelSWLargestSimplest, type="response",newdata=SectorsTableForAlrgestColoniesSkoklholm)      
SectorsTableForAlrgestColoniesSkoklholm$Prediction<-predict(topModelSWLargestSimplest, type="response",newdata=SectorsTableForAlrgestColoniesSkoklholm) 




predDetcts <-vector()
corPreds <- vector()
corPreds00 <- vector()
corPreds11 <- vector()
corPreds01 <- vector()
corPreds10 <- vector()

for(i in (1:100)) {
  predDetcts <- ifelse(mu.NullMod <(i/100),0,1)
  preds <- predDetcts
  predObs<-data.frame(preds,obsDetectAlfl)
  corPredsAll <- ((length(predObs[obsDetectAlfl==0 & preds == 0,2])) + (length(predObs[obsDetectAlfl==1 & preds == 1,2])))
  corPreds00all <- (length(predObs[obsDetectAlfl==0 & preds == 0,2]))
  corPreds11all <- (length(predObs[obsDetectAlfl==1 & preds == 1,2]))
  corPreds01all <- (length(predObs[obsDetectAlfl==0 & preds == 1,2]))
  corPreds10all <- (length(predObs[obsDetectAlfl==1 & preds == 0,2]))
  corPreds <- c(corPreds,corPredsAll)
  corPreds00 <- c(corPreds00,corPreds00all)
  corPreds11 <- c(corPreds11,corPreds11all)
  corPreds01 <- c(corPreds01,corPreds01all)
  corPreds10 <- c(corPreds10,corPreds10all)
  rm(predDetcts)
  rm(preds)
  rm(predObs)
  rm(corPredsAll)
  rm(corPreds00all)
  rm(corPreds11all)
  rm(corPreds01all)
  rm(corPreds10all)
}

sens<-corPreds11/(corPreds11+corPreds10)
spec<-corPreds00/(corPreds00+corPreds01)

OA <- corPreds/length(obsDetectAlfl) #### Overall Accuracy
TSS<-(sens+spec)-1 #### True Skill Statistics
OR<-(corPreds00+corPreds11)/(corPreds01+corPreds10)
#### Odds Ratio


cutpoint.Nullmod <- which(TSS==max(TSS))
OA.Nullmod <- OA[cutpoint.Nullmod]
TSS.Nullmod <- TSS[cutpoint.Nullmod]
OR.Nullmod <- OR[cutpoint.Nullmod]
sens.Nullmod <- sens[cutpoint.Nullmod]
spec.Nullmod <- spec[cutpoint.Nullmod]


#To identify presence/absence prediction use the cut off point (cutpoint.Nullmod) where the true skill statistic (TSS) is maximum.
#that translates to 0.04 for predicting the largest colonies on Skokholm with SW wind, using the model of SW wind of largest colonies on Skomer.

#TRUE presence
length(SectorsTableForAlrgestColoniesSkoklholm$FID[SectorsTableForAlrgestColoniesSkoklholm$ColPresence==1 &SectorsTableForAlrgestColoniesSkoklholm$Prediction>=0.04])
#FALSE presence
length(SectorsTableForAlrgestColoniesSkoklholm$FID[SectorsTableForAlrgestColoniesSkoklholm$ColPresence==0 &SectorsTableForAlrgestColoniesSkoklholm$Prediction>=0.04])


#TRUE absence
length(SectorsTableForAlrgestColoniesSkoklholm$FID[SectorsTableForAlrgestColoniesSkoklholm$ColPresence==0 &SectorsTableForAlrgestColoniesSkoklholm$Prediction<0.04])
#FALSE absence
length(SectorsTableForAlrgestColoniesSkoklholm$FID[SectorsTableForAlrgestColoniesSkoklholm$ColPresence==1 &SectorsTableForAlrgestColoniesSkoklholm$Prediction<0.04])







######################################