
#library("pscl")
#library("dplyr")
library("tcltk")
#library("nortest")
library("MuMIn")
library("circular")

library(MASS)



library(CircStats)

library(arm)
library(e1071)  #for the kurtosis and skewness functions


library(DescTools) # for MCFadden pseudo r square

# require(mctest)
# 
# require(foreign)
# 
# require(reshape2)


# 
# 
#   fileName <- tclvalue(tkgetSaveFile())
#   write.csv(SectorsTable, file = fileName,row.names=FALSE)
# 

#FOR INPUT DATA USE:
#D:/ArcGIS/Skomer/13thVersion48Sections/71SectionsTable/SW/SWAllWind2mSurfaceHighestResMinHeight10MinDistFromTop15SlopeSectioned.csv

inputData<-read.csv(file.choose())

inputData<-inputData[inputData$Sector!=0,]

inputDataBackUP<-inputData

#inputDataToWrite<-inputData[,c("Points_0","Points_1","Points_2","Slope","Count","Area","Density","Sector","Aspect" )]
#SectorsTableRawToWrite<-SectorsTableRaw[,c("Count","Area","Density","X_Centre","Y_Centre","Sector","SolarMean","MeanSectorSlope","MeanSectorAspectCircular")]
# 
# 
# SectorsTableRawToWrite$ApsectClass[SectorsTableRawToWrite$MeanSectorAspectCircular>=135 & SectorsTableRawToWrite$MeanSectorAspectCircular<315]<-"WindWard"
# SectorsTableRawToWrite$ApsectClass[SectorsTableRawToWrite$MeanSectorAspectCircular>=315]<-"leeWard"
# SectorsTableRawToWrite$ApsectClass[SectorsTableRawToWrite$MeanSectorAspectCircular<135]<-"leeWard"
# 
# SectorsTableRawToWrite$ApsectClass<-as.factor(SectorsTableRawToWrite$ApsectClass)
# 
# SectorsTableRawToWrite$ApsectClass = relevel(SectorsTableRawToWrite$ApsectClass, ref = "WindWard") # set leeWard as reference
# 
# table(SectorsTableRawToWrite$ApsectClass)


##FOR SECTORS TABLE USE:
#D:/ArcGIS/Skomer/13thVersion48Sections/71SectionsTable/SectionsTable_71SectionsWithCentroids.csv

SectorsTable<-read.csv(file.choose())

#SectorsTable<-SectorsTable[SectorsTable$Sector!=0,]
#SectorsTable[,c(6:42)]<-NA

#I cut section = 1.3 because this section does not have data points after the spatial refinement in GIS
#SectorsTable<-SectorsTable[SectorsTable$Sector!=1.3,]



for (sector in SectorsTable$Sector) {
  #For MeanU statistics
  SectorsTable$MeanUMedian[SectorsTable$Sector==sector]<-median(inputData$MeanU[inputData$Sector==sector])
  SectorsTable$MeanUIQR[SectorsTable$Sector==sector]<- IQR(inputData$MeanU[inputData$Sector==sector])
  #SectorsTable$MeanUMax[SectorsTable$Sector==sector]<-max(inputData$MeanU[inputData$Sector==sector])
  #SectorsTable$MeanUKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$MeanU[inputData$Sector==sector])
  SectorsTable$MeanUSkewness[SectorsTable$Sector==sector]<-skewness(inputData$MeanU[inputData$Sector==sector])
  SectorsTable$MeanUCV[SectorsTable$Sector==sector]<-100*(sd(inputData$MeanU[inputData$Sector==sector])/mean(inputData$MeanU[inputData$Sector==sector]))
  #For Horizontal speed statistics
  SectorsTable$HorizontalMedian[SectorsTable$Sector==sector]<-median(inputData$Horizontal[inputData$Sector==sector])
  SectorsTable$HorizontalIQR[SectorsTable$Sector==sector]<-IQR(inputData$Horizontal[inputData$Sector==sector])
  #SectorsTable$HorizontalMax[SectorsTable$Sector==sector]<-max(inputData$Horizontal[inputData$Sector==sector])
  SectorsTable$HorizontalSkewness[SectorsTable$Sector==sector]<-skewness(inputData$Horizontal[inputData$Sector==sector])
  #SectorsTable$HorizontalKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$Horizontal[inputData$Sector==sector])
  SectorsTable$HorizontalCV[SectorsTable$Sector==sector]<-100*(sd(inputData$Horizontal[inputData$Sector==sector])/mean(inputData$Horizontal[inputData$Sector==sector]))
  
  #For Pressure statistics
  SectorsTable$PMedian[SectorsTable$Sector==sector]<-median(inputData$P[inputData$Sector==sector])
  SectorsTable$PIQR[SectorsTable$Sector==sector]<-IQR(inputData$P[inputData$Sector==sector])
  #SectorsTable$PMax[SectorsTable$Sector==sector]<-max(inputData$P[inputData$Sector==sector])
  #SectorsTable$PKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$P[inputData$Sector==sector])
  SectorsTable$PSkewness[SectorsTable$Sector==sector]<-skewness(inputData$P[inputData$Sector==sector])
  SectorsTable$PCV[SectorsTable$Sector==sector]<-100*(sd(inputData$P[inputData$Sector==sector])/mean(inputData$P[inputData$Sector==sector]))
  #For TKE statistics
  SectorsTable$TKEMedian[SectorsTable$Sector==sector]<-median(inputData$K[inputData$Sector==sector])
  SectorsTable$TKEIQR[SectorsTable$Sector==sector]<-IQR(inputData$K[inputData$Sector==sector])
  #SectorsTable$TKEMax[SectorsTable$Sector==sector]<-max(inputData$K[inputData$Sector==sector])
  #SectorsTable$TKEKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$K[inputData$Sector==sector])
  SectorsTable$TKESkewness[SectorsTable$Sector==sector]<-skewness(inputData$K[inputData$Sector==sector])
  SectorsTable$TKECV[SectorsTable$Sector==sector]<-100*(sd(inputData$K[inputData$Sector==sector])/mean(inputData$K[inputData$Sector==sector]))
  #For TI statistics
  SectorsTable$TIMedian[SectorsTable$Sector==sector]<-median(inputData$TI[inputData$Sector==sector])
  SectorsTable$TIIQR[SectorsTable$Sector==sector]<-IQR(inputData$TI[inputData$Sector==sector])
  #SectorsTable$TIMax[SectorsTable$Sector==sector]<-max(inputData$TI[inputData$Sector==sector])
  #SectorsTable$TIKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$TI[inputData$Sector==sector])
  SectorsTable$TISkewness[SectorsTable$Sector==sector]<-skewness(inputData$TI[inputData$Sector==sector])
  SectorsTable$TICV[SectorsTable$Sector==sector]<-100*(sd(inputData$TI[inputData$Sector==sector])/mean(inputData$TI[inputData$Sector==sector]))
  #For Vertical Wind statistics
  SectorsTable$U_2Median[SectorsTable$Sector==sector]<-median(inputData$U_2[inputData$Sector==sector])
  SectorsTable$U_2IQR[SectorsTable$Sector==sector]<-IQR(inputData$U_2[inputData$Sector==sector])
  #SectorsTable$U_2Max[SectorsTable$Sector==sector]<-max(inputData$U_2[inputData$Sector==sector])
  #SectorsTable$U_2Kurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$U_2[inputData$Sector==sector])
  SectorsTable$U_2Skewness[SectorsTable$Sector==sector]<-skewness(inputData$U_2[inputData$Sector==sector])
  SectorsTable$U_2CV[SectorsTable$Sector==sector]<-100*(sd(inputData$U_2[inputData$Sector==sector])/mean(inputData$U_2[inputData$Sector==sector]))
  #For Epsilon (Dissipation rate) Wind statistics
  SectorsTable$EpsilonMedian[SectorsTable$Sector==sector]<-median(inputData$Epsilon[inputData$Sector==sector])
  SectorsTable$EpsilonIQR[SectorsTable$Sector==sector]<-IQR(inputData$Epsilon[inputData$Sector==sector])
  #SectorsTable$EpsilonMax[SectorsTable$Sector==sector]<-max(inputData$Epsilon[inputData$Sector==sector])
  #SectorsTable$EpsilonKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$Epsilon[inputData$Sector==sector])
  SectorsTable$EpsilonSkewness[SectorsTable$Sector==sector]<-skewness(inputData$Epsilon[inputData$Sector==sector])
  SectorsTable$EpsilonCV[SectorsTable$Sector==sector]<-100*(sd(inputData$Epsilon[inputData$Sector==sector])/mean(inputData$Epsilon[inputData$Sector==sector]))
  #For Nut (Kinematic Viscosity) Wind statistics
  SectorsTable$NutMedian[SectorsTable$Sector==sector]<-median(inputData$Nut[inputData$Sector==sector])
  SectorsTable$NutIQR[SectorsTable$Sector==sector]<-IQR(inputData$Nut[inputData$Sector==sector])
  #SectorsTable$NutMax[SectorsTable$Sector==sector]<-max(inputData$Nut[inputData$Sector==sector])
  #SectorsTable$NutKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$Nut[inputData$Sector==sector])
  SectorsTable$NutSkewness[SectorsTable$Sector==sector]<-skewness(inputData$Nut[inputData$Sector==sector])
  SectorsTable$NutCV[SectorsTable$Sector==sector]<-100*(sd(inputData$Nut[inputData$Sector==sector])/mean(inputData$Nut[inputData$Sector==sector]))
  
  #For Gusts wind statistics
  SectorsTable$GustsMedian[SectorsTable$Sector==sector]<-median(inputData$Gusts[inputData$Sector==sector])
  SectorsTable$GustsIQR[SectorsTable$Sector==sector]<-IQR(inputData$Gusts[inputData$Sector==sector])
  #SectorsTable$GustsMax[SectorsTable$Sector==sector]<-max(inputData$Gusts[inputData$Sector==sector])
  #SectorsTable$GustsKurtosis[SectorsTable$Sector==sector]<-kurtosis(inputData$Gusts[inputData$Sector==sector])
  SectorsTable$GustsSkewness[SectorsTable$Sector==sector]<-skewness(inputData$Gusts[inputData$Sector==sector])
  SectorsTable$GustsCV[SectorsTable$Sector==sector]<-100*(sd(inputData$Gusts[inputData$Sector==sector])/mean(inputData$Gusts[inputData$Sector==sector]))
  
  #SectorsTable$MeanCliffheight[SectorsTable$Sector==sector]<-mean(inputData$Points_2[inputData$Sector==sector])
  
  
  SectorsTable$SolarMedian[SectorsTable$Sector==sector]<-median(inputData$solarRad[inputData$Sector==sector])
  SectorsTable$SolarMean[SectorsTable$Sector==sector]<-mean(inputData$solarRad[inputData$Sector==sector])
  
  
  SectorsTable$MeanSectorSlope[SectorsTable$Sector==sector]<-mean(inputData$Slope[inputData$Sector==sector])
  
  
  # #FUNCTIONS USED TO FIND CIRCULAR MEANS
  deg2rad <- function(deg) {(deg * pi) / (180)}
  rad2deg <- function(rad) {(rad * 180) / (pi)}
  
  temp<-deg2rad(inputData$Aspect[inputData$Sector==sector])
  #   
  temp2<-circ.mean( temp ) 
  #   
  temp3<-rad2deg(temp2)
  #   
  #   #IF MEAN CIRCULAR VALUE IS NEGATIVE, ADD 360 TO CORRECT IT
  temp3[temp3<0 & !is.na(temp3)]<-temp3[temp3<0 & !is.na(temp3)]+360
  
  SectorsTable$MeanSectorAspectCircular[SectorsTable$Sector==sector]<-temp3
 
  
}



#Keep a sector table UNSTARDARDIZED
SectorsTableRaw<-SectorsTable #This is used to assess models of slope and mean cliff orientation (Aspect) on Skomer



#Make stdize to standardize with 2 standard deviations, exactly as the standardize from package "arm" does
#for the glm object
twosd <- function(v) 2 * sd(v, na.rm = TRUE)



SectorsTable$MeanUMedian<-stdize(SectorsTable$MeanUMedian , center = TRUE, scale = twosd)
SectorsTable$MeanUIQR<-stdize(SectorsTable$MeanUIQR , center = TRUE, scale = twosd)
#SectorsTable$MeanUMax<-stdize(SectorsTable$MeanUMax , center = TRUE, scale = twosd)
SectorsTable$MeanUCV<-stdize(SectorsTable$MeanUCV , center = TRUE, scale = twosd)
#SectorsTable$MeanUKurtosis<-stdize(SectorsTable$MeanUKurtosis , center = TRUE, scale = twosd)
SectorsTable$MeanUSkewness<-stdize(SectorsTable$MeanUSkewness , center = TRUE, scale = twosd)

#For Horizontal speed statistics
SectorsTable$HorizontalMedian<-stdize(SectorsTable$HorizontalMedian , center = TRUE, scale = twosd)
SectorsTable$HorizontalIQR<-stdize(SectorsTable$HorizontalIQR , center = TRUE, scale = twosd)
#SectorsTable$HorizontalMax<-stdize(SectorsTable$HorizontalMax , center = TRUE, scale = twosd)
SectorsTable$HorizontalCV<-stdize(SectorsTable$HorizontalCV , center = TRUE, scale = twosd)
#SectorsTable$HorizontalKurtosis<-stdize(SectorsTable$HorizontalKurtosis , center = TRUE, scale = twosd)
SectorsTable$HorizontalSkewness<-stdize(SectorsTable$HorizontalSkewness , center = TRUE, scale = twosd)

#For Pressure statistics
SectorsTable$PMedian<-stdize(SectorsTable$PMedian , center = TRUE, scale = twosd)
SectorsTable$PIQR<-stdize(SectorsTable$PIQR , center = TRUE, scale = twosd)
#SectorsTable$PMax<-stdize(SectorsTable$PMax , center = TRUE, scale = twosd)
SectorsTable$PCV<-stdize(SectorsTable$PCV , center = TRUE, scale = twosd)
#SectorsTable$PKurtosis<-stdize(SectorsTable$PKurtosis , center = TRUE, scale = twosd)
SectorsTable$PSkewness<-stdize(SectorsTable$PSkewness , center = TRUE, scale = twosd)

#For TKE statistics
SectorsTable$TKEMedian<-stdize(SectorsTable$TKEMedian , center = TRUE, scale = twosd)
SectorsTable$TKEIQR<-stdize(SectorsTable$TKEIQR , center = TRUE, scale = twosd)
#SectorsTable$TKEMax<-stdize(SectorsTable$TKEMax , center = TRUE, scale = twosd)
SectorsTable$TKECV<-stdize(SectorsTable$TKECV , center = TRUE, scale = twosd)
#SectorsTable$TKEKurtosis<-stdize(SectorsTable$TKEKurtosis , center = TRUE, scale = twosd)
SectorsTable$TKESkewness<-stdize(SectorsTable$TKESkewness , center = TRUE, scale = twosd)

#For TI statistics
SectorsTable$TIMedian<-stdize(SectorsTable$TIMedian , center = TRUE, scale = twosd)
SectorsTable$TIIQR<-stdize(SectorsTable$TIIQR , center = TRUE, scale = twosd)
#SectorsTable$TIMax<-stdize(SectorsTable$TIMax , center = TRUE, scale = twosd)
SectorsTable$TICV<-stdize(SectorsTable$TICV , center = TRUE, scale = twosd)
#SectorsTable$TIKurtosis<-stdize(SectorsTable$TIKurtosis , center = TRUE, scale = twosd)
SectorsTable$TISkewness<-stdize(SectorsTable$TISkewness , center = TRUE, scale = twosd)

#For Vertical Wind statistics
SectorsTable$U_2Median<-stdize(SectorsTable$U_2Median , center = TRUE, scale = twosd)
SectorsTable$U_2IQR<-stdize(SectorsTable$U_2IQR , center = TRUE, scale = twosd)
#SectorsTable$U_2Max<-stdize(SectorsTable$U_2Max , center = TRUE, scale = twosd)
SectorsTable$U_2CV<-stdize(SectorsTable$U_2CV , center = TRUE, scale = twosd)
#SectorsTable$U_2Kurtosis<-stdize(SectorsTable$U_2Kurtosis , center = TRUE, scale = twosd)
SectorsTable$U_2Skewness<-stdize(SectorsTable$U_2Skewness , center = TRUE, scale = twosd)

#For Epsilon (Dissipation rate) Wind statistics
SectorsTable$EpsilonMedian<-stdize(SectorsTable$EpsilonMedian , center = TRUE, scale = twosd)
SectorsTable$EpsilonIQR<-stdize(SectorsTable$EpsilonIQR , center = TRUE, scale = twosd)
#SectorsTable$EpsilonMax<-stdize(SectorsTable$EpsilonMax , center = TRUE, scale = twosd)
SectorsTable$EpsilonCV<-stdize(SectorsTable$EpsilonCV , center = TRUE, scale = twosd)
#SectorsTable$EpsilonKurtosis<-stdize(SectorsTable$EpsilonKurtosis , center = TRUE, scale = twosd)
SectorsTable$EpsilonSkewness<-stdize(SectorsTable$EpsilonSkewness , center = TRUE, scale = twosd)

#For Nut (Kinematic Viscosity) Wind statistics
SectorsTable$NutMedian<-stdize(SectorsTable$NutMedian , center = TRUE, scale = twosd)
SectorsTable$NutIQR<-stdize(SectorsTable$NutIQR , center = TRUE, scale = twosd)
#SectorsTable$NutMax<-stdize(SectorsTable$NutMax , center = TRUE, scale = twosd)
SectorsTable$NutCV<-stdize(SectorsTable$NutCV , center = TRUE, scale = twosd)
#SectorsTable$NutKurtosis<-stdize(SectorsTable$NutKurtosis , center = TRUE, scale = twosd)
SectorsTable$NutSkewness<-stdize(SectorsTable$NutSkewness , center = TRUE, scale = twosd)

#For Gusts wind statistics
SectorsTable$GustsMedian<-stdize(SectorsTable$GustsMedian , center = TRUE, scale = twosd)
SectorsTable$GustsIQR<-stdize(SectorsTable$GustsIQR , center = TRUE, scale = twosd)
#SectorsTable$GustsMax<-stdize(SectorsTable$GustsMax , center = TRUE, scale = twosd)
#SectorsTable$GustsKurtosis<-stdize(SectorsTable$GustsKurtosis , center = TRUE, scale = twosd)
SectorsTable$GustsCV<-stdize(SectorsTable$GustsCV , center = TRUE, scale = twosd)
SectorsTable$GustsSkewness<-stdize(SectorsTable$GustsSkewness , center = TRUE, scale = twosd)

#SectorsTable$MeanCliffheight<-stdize(SectorsTable$MeanCliffheight , center = TRUE, scale = twosd)
SectorsTable$MeanSectorSlope<-stdize(SectorsTable$MeanSectorSlope , center = TRUE, scale = twosd)
# SectorsTable$MeanSectorAspect<-stdize(SectorsTable$MeanSectorAspect , center = TRUE, scale = twosd)

#SectorsTable$SolarMedian<-stdize(SectorsTable$SolarMedian , center = TRUE, scale = twosd)
SectorsTable$SolarMean<-stdize(SectorsTable$SolarMean , center = TRUE, scale = twosd)


#REMOVE ALL SECTIONS THAT DO NOT HAVE ANY WIND DATA. THIS IS NECESSARY AS SOME SECTIONS ARE NEGLECTED AFTER SPATIAL REFINEMENT
SectorsTable<-SectorsTable[complete.cases(SectorsTable$HorizontalSkewness), ]







